/// <reference types="bn.js" />
import { BN } from "@project-serum/anchor";
import { PublicKey } from "@solana/web3.js";
import { TransactionBuilder } from "@orca-so/common-sdk";
import { EscrowContext, PDA } from "..";
import { TradeData } from "../types";
export declare class TradeClient {
    ctx: EscrowContext;
    data: TradeData;
    publicKey: PublicKey;
    pda: PDA;
    configId: string;
    constructor(ctx: EscrowContext, publicKey: PublicKey, data: TradeData, pda: PDA, configid: string);
    static getTrade(ctx: EscrowContext, configId: string, tradeId: BN): Promise<TradeClient>;
    release(): Promise<TransactionBuilder>;
    callArbitrator(caller: PublicKey): Promise<TransactionBuilder>;
    resolveDispute(arbitrator: PublicKey, disputeAction: object, compensationAction: object): Promise<TransactionBuilder>;
    cancelBuy(buyer: PublicKey): Promise<TransactionBuilder>;
    refresh(): Promise<TradeClient>;
}
