/// <reference types="bn.js" />
import { BN } from "@project-serum/anchor";
import { PublicKey } from "@solana/web3.js";
import { TransactionBuilder } from "@orca-so/common-sdk";
import { EscrowContext, PDA } from "../";
import { TradeOrderData } from "../types";
export declare class TradeOrderClient {
    ctx: EscrowContext;
    data: TradeOrderData;
    publicKey: PublicKey;
    pda: PDA;
    configId: string;
    constructor(ctx: EscrowContext, publicKey: PublicKey, data: TradeOrderData, pda: PDA, configid: string);
    static getOrder(ctx: EscrowContext, configId: string, orderId: BN): Promise<TradeOrderClient>;
    static makeSellOrder(ctx: EscrowContext, configId: string, seller: PublicKey, tokenMint: PublicKey, bondType: object, tokenAmount: BN, fiatAmount: BN): Promise<{
        tx: TransactionBuilder;
        id: BN;
    }>;
    static makeBuyOrder(ctx: EscrowContext, configId: string, buyer: PublicKey, tokenMint: PublicKey, tokenAmount: BN, fiatAmount: BN): Promise<{
        tx: TransactionBuilder;
        id: BN;
    }>;
    cancelOrder(user: PublicKey): Promise<TransactionBuilder>;
    joinOrder(user: PublicKey): Promise<TransactionBuilder>;
    release(): Promise<TransactionBuilder>;
    callArbitrator(caller: PublicKey): Promise<TransactionBuilder>;
    resolveDispute(arbitrator: PublicKey, disputeAction: object, compensationAction: object): Promise<TransactionBuilder>;
    refresh(): Promise<TradeOrderClient>;
}
